#!/bin/bash
# Pear Limited

apt_init() {
  echo "================================================"
  echo "begin execute apt installation "

  sudo apt update

  # install dependency package
  sudo apt  -y install   build-essential
  sudo apt  -y install   parted
  sudo apt  -y install   libelf-dev 
  sudo apt  -y install   libcurl4-openssl-dev   
  sudo apt  -y install   libjansson-dev
  sudo apt  -y install   curl 
  sudo apt  -y install   openssh-server 
  sudo apt  -y install   vim
  sudo apt  -y install   xfsprogs
  sudo apt  -y install   cpulimit
  sudo apt  -y install   sysstat
  sudo apt  -y install   ntpdate

  sudo apt  -y install   net-tools
  sudo apt  -y install   ethtool

  sudo apt  -y install   vlan 
  sudo apt  -y install   pppoeconf
  modprobe 8021q

  sudo apt  -y install   linux-tools-common
  sudo apt  -y install   linux-tools-generic  
  sudo apt  -y install   linux-cloud-tools-generic

  if [[ "p_"${FILE_SYSTEM} = "p_exfat" ]]; then
    sudo apt  -y install   exfat-utils
    sudo apt  -y remove    exfat-fuse
    sudo apt  -y autoremove 
  fi

  if docker ps  
  then
    echo "docker existed"
  else
    sudo apt  -y install docker docker.io 
  fi

  sudo apt  -y install nload 
  sudo apt  -y install iftop iotop htop  ifstat 


  efatfuse=`dpkg -l | grep exfat-fuse | awk '{print $2}'`
  if [[ -n ${efatfuse} ]]; then
    echo "remove exfat-fuse failt "
  fi
  sleep 3
  echo "finished install apt package !"
}


apt_init
