echo "-------------------------begin config kernel parameter-------------------------"
cp /etc/security/limits.conf /etc/security/limits.conf.bak  
cp /etc/sysctl.conf  /etc/sysctl.conf.bak 
cp /etc/systemd/system.conf /etc/systemd/system.conf.bak

diff  /etc/security/limits.conf   /root/pear/config/limits.conf  > /tmp/diff_limits.log 
diff  /etc/sysctl.conf /root/pear/config/sysctl.conf  > /tmp/diff_sysctl.log 
diff  /etc/systemd/system.conf   /root/pear/config/system.conf  > /tmp/diff_system.log 

cp -f /root/pear/config/limits.conf  /etc/security/limits.conf
cp -f /root/pear/config/sysctl.conf  /etc/sysctl.conf
cp -f /root/pear/config/system.conf  /etc/systemd/system.conf

# user aliyun source
# cp /etc/apt/sources.list /etc/apt/sources.list.bak 
# cp -f /root/pear/config/sources.list /etc/apt/sources.list 

sysctl -p 1> /tmp/sysctl.result

echo "-------------------------finish config kernel parameter-------------------------"

kernel_optimizer(){
 
  result=`cat  /etc/sysctl.conf | grep 'net.ipv6.conf.default.disable_ipv6 = 1'`
  if [[ -n  ${result} ]]; then
    echo "optimized "
    return 0
  fi

  # limits parameter
  echo "* soft nofile 131072" >> /etc/security/limits.conf
  echo "* hard nofile 131072" >> /etc/security/limits.conf
  echo "* soft nproc 131072" >> /etc/security/limits.conf
  echo "* hard nproc  131072" >> /etc/security/limits.conf
  echo "DefaultLimitNOFILE=131072"   >> /etc/systemd/system.conf

  # memory optimize
  echo "vm.swappiness = 0">> /etc/sysctl.conf  

  # net.core 
  echo "net.core.netdev_max_backlog = 30000" >>   /etc/sysctl.conf
  echo "net.core.optmem_max = 524288" >>   /etc/sysctl.conf
  echo "net.core.rmem_max = 524288" >>   /etc/sysctl.conf
  echo "net.core.rmem_default = 524288" >>   /etc/sysctl.conf
  echo "net.core.wmem_max = 524288" >>   /etc/sysctl.conf
  echo "net.core.wmem_default = 262144" >>   /etc/sysctl.conf
  echo "net.core.somaxconn = 262144" >>   /etc/sysctl.conf

  # ip4 
  echo "net.ipv4.ip_local_port_range = 1024 65535" >>   /etc/sysctl.conf

  # tcp4 
  echo "net.ipv4.tcp_base_mss = 1400" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_sack = 1" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_no_metrics_save = 1" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_slow_start_after_idle = 0" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_rmem = 4096 524288 524288" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_wmem = 4096 262144 524288" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_fastopen = 3" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_keepalive_time = 1800" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_keepalive_intvl = 30" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_keepalive_probes = 3" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_fin_timeout = 30" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_max_syn_backlog = 262144" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_synack_retries = 3" >>   /etc/sysctl.conf
  echo "net.ipv4.tcp_syn_retries = 2" >>   /etc/sysctl.conf

  echo "net.ipv6.conf.all.disable_ipv6 = 1" >>   /etc/sysctl.conf
  echo "net.ipv6.conf.default.disable_ipv6 = 1" >>   /etc/sysctl.conf
  echo "net.netfilter.nf_conntrack_buckets = 131072" >>   /etc/sysctl.conf
  echo "net.nf_conntrack_max = 524288" >>   /etc/sysctl.conf
  
  sysctl -p
}