echo "----------------------------Init begin----------------------------------------------"

PARTED="/root/pear/parted.sh"

if [ -z "$PEAR_MACHINE_NAME" ]
then
    echo "PEAR_MACHINE_NAME cant be NULL"
    exit 1
fi

rm -rf /root/pear/*

mkdir -p /root/pear/multidial
mkdir -p /root/pear/tools
mkdir -p /root/pear/log
mkdir -p /root/pear/config

echo PEAR_MACHINE_NAME=${PEAR_MACHINE_NAME} >> /root/pear/pear_config.sh
echo FILE_SYSTEM=${FILE_SYSTEM} >> /root/pear/pear_config.sh
echo PART_SIZE=${PART_SIZE} >> /root/pear/pear_config.sh
echo DIAL_ACCOUNT_NUMBER=${DIAL_ACCOUNT_NUMBER} >> /root/pear/pear_config.sh
echo DNS=${DNS} >> /root/pear/pear_config.sh
echo FallbackDNS=${FallbackDNS} >> /root/pear/pear_config.sh
echo 
echo "make config file"

cp /root/gitee/auto_install/parted_en.sh   ${PARTED}

cp /root/gitee/auto_install/*.sh /root/pear/
cp /root/gitee/auto_install/tools/* /root/pear/tools/
cp /root/gitee/auto_install/config/* /root/pear/config/

cp /root/gitee/auto_install/multidial/accounts/${PEAR_MACHINE_NAME}_account.txt  /root/pear/multidial/
cp /root/gitee/auto_install/multidial/pear_multiple  /root/pear/multidial/
cp /root/gitee/auto_install/multidial/pear_findppp  /root/pear/multidial/
cp /root/gitee/auto_install/multidial/*.sh  /root/pear/multidial/

cp /root/gitee/auto_install/disk_parm/${PEAR_MACHINE_NAME}_parm.conf /root/pear/ 

cp -r /root/gitee/auto_install/pear_init/etc/* /etc

if [[ -n ${DIAL_ACCOUNT_NUMBER} ]]; then
  sed -i "s/DIAL_ACCOUNT_NUMBER=100/DIAL_ACCOUNT_NUMBER=${DIAL_ACCOUNT_NUMBER}/g"  ${PARTED}
  sed -i "s/DIAL_ACCOUNT_NUMBER=100/DIAL_ACCOUNT_NUMBER=${DIAL_ACCOUNT_NUMBER}/g"  /root/pear/dial.sh
fi

if [ -n "$DNS" ]
then
    sed -i "s/119.29.29.29/${DNS}/g"  ${PARTED} 
fi
if [ -n "$FallbackDNS" ]
then
    sed -i "s/180.76.76.76/${FallbackDNS}/g"  ${PARTED}
fi

if [ -n "$PART_SIZE" ]
then
    sed -i "s/PART_SIZE=186/PART_SIZE=${PART_SIZE}/g"   ${PARTED}
    sed -i "s/PART_SIZE=186/PART_SIZE=${PART_SIZE}/g"    /root/pear/pear_mount_on_running.sh
fi
if [ -n "$PART_NUMBER" ]
then
    sed -i "s/PART_NUMBER=10/PART_NUMBER=${PART_NUMBER}/g"    ${PARTED}
fi

if [ -n "$FILE_SYSTEM" ]
then
    sed -i "s/DATA_DISK_TYPE=\"ext4\"/DATA_DISK_TYPE=\"${FILE_SYSTEM}\"/g"   ${PARTED}
    sed -i "s/DATA_DISK_TYPE=\"ext4\"/DATA_DISK_TYPE=\"${FILE_SYSTEM}\"/g"  /root/pear/pear_mount_on_running.sh
fi

sed -i "s/PEAR_MACHINE_NAME=\"\"/PEAR_MACHINE_NAME=\"${PEAR_MACHINE_NAME}\"/g"   ${PARTED}
sed -i "s/PEAR_MACHINE_NAME=\"\"/PEAR_MACHINE_NAME=\"${PEAR_MACHINE_NAME}\"/g"   /root/pear/dial.sh
sed -i "s/PEAR_MACHINE_NAME=\"\"/PEAR_MACHINE_NAME=\"${PEAR_MACHINE_NAME}\"/g"   /root/pear/tools/pear_debug.sh

chmod +x ${PARTED}
chmod +x /root/pear/pear_mount_on_running.sh

if [[ ! -f /root/pear/pear_remount.sh ]]; then
  /root/pear/pear_mount_on_running.sh
fi

if [[ ! -f /root/pear/pear_remount.sh ]]; then
  echo "/root/pear/pear_remount.sh  not existed and could not be generated by pear_mount_on_running.sh , please check "
  echo "now exit "
  exit 0
fi

filesize=` ls -l /root/pear/pear_remount.sh   | awk '{print $5}' `
if [[ ${filesize} -eq 0 ]]; then
  lsblk -o PARTUUID,MOUNTPOINT | grep sata | awk '{system("echo mount PARTUUID=" $1 " " $2)}' >>  /root/pear/pear_remount.sh
fi    

if [[ $FILE_SYSTEM != "exfat" ]]; then
  sed -i '/exfat/d' /etc/init.d/pear_init 
fi

if [[ -f /etc/init.d/pear_ddns  ]]; then
  pear_ddns_exist=`ps -aux | grep pear_ddns | grep -v color `
  if [[ -n ${pear_ddns_exist} ]]; then
    killall pear_ddns
  fi
fi

cp -r /root/gitee/auto_install/pear_ddns/etc/* /etc
cp -r /root/gitee/auto_install/pear_ddns/usr/* /usr

if [[ a${NETWORK_MODE} = "aSTATICIP" ]]; then
  sed -i "s/pear_ddns \&/pear_ddns --sub_domain=${PEAR_MACHINE_NAME}   \&/g" /etc/init.d/pear_ddns     
else
  sed -i "s/pear_ddns \&/pear_ddns --sub_domain=${PEAR_MACHINE_NAME}  --nic=ppp0 \&/g" /etc/init.d/pear_ddns     
fi

chmod +x /etc/init.d/pear_ddns 

# /etc/init.d/pear_ddns start  >>  /tmp/pear_ddns_result  2>&1
# /root/pear/parted.sh  gdns

### 
chmod +x /root/pear/multidial/*
chmod +x /root/pear/*
chmod +x /root/pear/tools/*
chmod +r /root/pear/config/*
chmod +x /etc/init.d/pear*


killall -9 pear_debug.sh 
kill -9  `pgrep pear_debug.sh`
/root/pear/tools/pear_debug.sh > /dev/null 2>&1 &

echo "--------------------------Init end------------------------------------------------"