#!/bin/bash

DATA_DISK_TYPE="ext4"
PART_SIZE=186
source /root/pear/get_mount_command.sh

if [[ ! -f  /root/pear/pear_remount.sh ]]; then
  lsblk -o PARTUUID,MOUNTPOINT | grep sata | awk '{print "'"$base_mount_cmd"'"  " PARTUUID=" $1  "  " $2}'  > /root/pear/pear_remount.sh
  chmod +x /root/pear/pear_remount.sh
  # exit 0
fi

ejected_satas=`  mount | grep sata | grep ejected | awk '{print $3}'   `
if [[ -n ${ejected_satas} ]]; then
  for ejected_sata in ${ejected_satas[@]};
  do 
    echo "to do "
    # 1. get tencent docker
    # 2. stop tencent docker
    # 3. check being used by httpd, if yes , stop httpd
    # 4. umount
    # 5. mount 
    # 6. start tencent docker
    # 7. xc_cdn.sh restart 
  done
fi

rootfilesystemname=`df -hT | grep ext4 | grep -e '/$' | awk '{print $1}' | awk -F/ '{print $3}'`
echo "root system: " ${rootfilesystemname}

disks=`lsblk -o NAME,TYPE | grep disk  | awk '{print $1}'` 

rootdisk=${rootfilesystemname}
for disk in ${disks[@]}
do
  length=${#disk}
  if [[ ${rootfilesystemname:0:${length}} == ${disk} ]]; then
    rootdisk=${disk}
    echo "now get root disk: " ${rootdisk}
    break
  fi
done 

part_device_names=`lsblk -o PARTUUID,KNAME,FSTYPE,SIZE,TYPE,MOUNTPOINT | grep part | grep -v  ${rootdisk}  | grep -v sata   | awk '{system("echo /dev/" $2)}'`



for part_device in ${part_device_names[@]}
do

  # check fstype
  part_fstype=`lsblk -o FSTYPE  ${part_device}  | grep -v FSTYPE`
  if [[ v${part_fstype} != v${DATA_DISK_TYPE} ]]; then
    echo "${part_device}, ${part_fstype} not expected, skip  "
    continue
  fi

  # check size 
  part_device_size=`lsblk -o SIZE  ${part_device} | grep -v SIZE | sed -e 's/G//g'`
  # SIZEOK="FALSE"
  # if [[ ${part_device_size}  >  $(( PART_SIZE-1 )) ]]; then
  #   if [[  ${part_device_size}  <  $(( PART_SIZE+1 )) ]]; then
  #     SIZEOK="TRUE"
  #   fi
  # fi
  # if [[ ${SIZEOK} == "FALSE" ]]; then
  #   echo "${part_device}, ${part_device_size}:  not expected, skip  "
  #   continue
  # fi
  
  # modified by yongming for float type
  if  expr ${part_device_size} \>  $(( PART_SIZE+2 ))  ||  expr ${part_device_size} \< $(( PART_SIZE-2 )) ; then
    echo "size  ${part_device_size} not expected, skip " ${part_device}
    continue
  fi

  MOUNT_OK="FALSE"
  part_device_partuuid=`lsblk -o PARTUUID ${part_device} | grep -v PARTUUID`

  part_device_remount_result=`cat /root/pear/pear_remount.sh | grep ${part_device_partuuid}`

  if [[ -n  ${part_device_remount_result} ]]; then
    echo "need remount  ${part_device}  ${part_device_partuuid} " 
    sataname=`cat /root/pear/pear_remount.sh | grep ${part_device_partuuid} | awk '{print $NF}'`
    echo "sataname: "${sataname}
    mkdir -p ${sataname}

    # to do: check mountpoint (/sata?) is used or not? mount | grep ${sataname}
    ${part_device_remount_result}  2> temp
    result=`cat temp`
    if [[ -z ${result} ]]; then
      MOUNT_OK="TRUE"
    fi
    rm -f temp 
  else
    satadisks='/sata*'
    # if [[ ${satadisks} == "/sata*" ]]; then
    #   echo "sata point not make , please execute /root/pear/parted.sh point "
    #   break
    # fi
    for sata_point in ${satadisks[@]}
    do
      if mountpoint -q ${sata_point} 
      then
         echo ${sata_point} "has mounted"  > /tmp/clearsata.txt
      else
        echo "get idle sata point : " ${sata_point}
        # added by ym for mulit mount begin
        if lsblk | grep -w ${sata_point}
        then
            echo "has mounted by lsblk , then skip ${sata_point}"
            continue
        fi
        # added by ym for mulit mount begin
        mountcmd="${base_mount_cmd} PARTUUID=${part_device_partuuid}  ${sata_point}"
        echo ${mountcmd}

        # added by ym for system part is full begin
        rm -rf ${sata_point}/*
        # added by ym for system part is full end

        ${mountcmd} 2> temp
        result=`cat temp`
        if [[ -z ${result} ]]; then
          echo ${mountcmd}  >>  /root/pear/pear_remount.sh
          MOUNT_OK="TRUE"
        else
          echo "mount ${part_device}  ${part_device_partuuid}  ${sata_point} fail  "
        fi
        
        rm -f temp 
        break
      fi
    done 
  fi

  if [[ ${MOUNT_OK} == "FALSE" ]]; then
    echo "to do here"
  fi
done
chmod +x /root/pear/pear_remount.sh
