#!/bin/bash 


PART_SIZE=920

part_ssd() {

for i in `lsblk | grep sd | grep -v sda | grep -v part | awk '{print $1}'`;
do 
   cmd="parted --script /dev/sd$i mklabel gpt mkpart primary 100MiB ${PART_SIZE}GiB" 
   echo $cmd 
done

for i in `lsblk | grep sd | grep -v sda | grep -v part | awk '{print $1}'`; 
do 
    cmd="mkfs.ext4  -F -O ^has_journal -T largefile /dev/${i}1" 
    echo ${cmd} 
    $cmd 
done
}

part_nvme() {

for part in /dev/nvme0n1  /dev/nvme1n1
do

   cmd="parted --script ${part}  mklabel gpt mkpart primary 100MiB $(( PART_SIZE*2 ))GiB" 
   echo $cmd
   $cmd
   for i in `seq 1`
   do 
        cmd="mkfs.ext4 -F -O ^has_journal -T largefile ${part}p${i}"
	echo ${cmd}   
   done
   mkfs.ext4 -F -O ^has_journal -T largefile /dev/nvme0n1p1
   mkfs.ext4 -F -O ^has_journal -T largefile /dev/nvme1n1p1

done
}

gen_mount_point() {
	for i in `seq 0 19 `
	do 
		cmd="mkdir -p /sata${i}"
		echo ${cmd}
		${cmd}
	done
	chmod -R 777 /sata*
}

mount_on_running() {
	
index=0

for i in `lsblk | grep sd | grep -v sda | grep -v part | awk '{print $1}'`
do    
     cmd="mount -o rw,noatime,nodiratime,lazytime,noiversion,nobarrier,noquota  /dev/${i}1 /sata${index}"
     echo ${cmd}
     ${cmd}
     let index=index+1
done


mount -o rw,noatime,nodiratime,lazytime,noiversion,nobarrier,noquota /dev/nvme0n1p1 /sata${index}
let index=index+1
mount -o rw,noatime,nodiratime,lazytime,noiversion,nobarrier,noquota /dev/nvme1n1p1 /sata${index}

}

#part_ssd
#part_nvme
#gen_mount_point
#mount_on_running

case "$1" in
    mount )  mount_on_running   ;;
esac
