#!/bin/bash
# 2019/09/24  16:48:44 CST : added by yongming 

# DATA_DISK_TYPE="ext4"
# source ../../get_mount_command.sh

source /root/pear/pear_config.sh

echo "PEAR_SYSTEM_PARTION_SIZE:  " $PEAR_SYSTEM_PARTION_SIZE

# set -x 

function pear_system_create()
{
   echo $FUNCNAME
   if [ ! -e ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_PARTION} ]
   then
        echo "fallocate and make ext4 file system"
        fallocate  -l ${PEAR_SYSTEM_PARTION_SIZE}  ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_PARTION}
        mkfs.ext4  -F -O ^has_journal -T largefile ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_PARTION}
   else
        echo "pear_partion already has ..."
   fi
}

function pear_system_point()
{
   echo $FUNCNAME
   rm -rf /sata*
   for i in `seq 0 ${DIAL_ACCOUNT_NUMBER}`
   do 
       mkdir -p  ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}/sata${i}

       rm -rf /sata${i}/*
       ln -sv ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}/sata${i}  /
   done
   chmod -R 777 ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}/sata*
   chmod -R 777 /sata${i}
   
}

function pear_system_mount()
{
   echo $FUNCNAME
   mkdir -p  ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}
   # if ! df | grep ${PEAR_SYSTEM_MOUNT} 

   if mountpoint -q ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}
   then
      echo "no need to mount --> ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}/"  
   else
      cmd="mount -o rw,noatime,nodiratime,lazytime  ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_PARTION} ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}"
      echo $cmd 
      $cmd
      # rm -rf ${PEAR_SYSTEM_PATH}/${PEAR_SYSTEM_MOUNT}/*
   fi
}

# pear_system_create
# pear_system_mount
# pear_system_point

# ln -sv ./mymount/  sata100
# -svf
# df -h
# /dev/loop0  1.0G  1.3M  956M   1% /home/ym/sata/mymount
# https://www.cnblogs.com/Clonglegs/p/11189714.html