#!/bin/bash
# Pear Limited
# 2019-09-19 10:53:12  First version


PEAR_MACHINE_NAME=""
MAX_SPEED_NETCARD=""
DIAL_ACCOUNT_NUMBER=100

find_max_speed_netcard() {
  netcards=`ifconfig | grep RUNNING | grep -v ppp | grep -v veth  | grep MULTICAST | awk '{print $1}' | sed -e 's/://g' | awk -F. '{print $1}' | uniq`
  maxnetcardspeed=0
  for netcard in ${netcards[@]}
  do
    # echo "check network card : "${netcard}
    cmd="ethtool ${netcard} | grep Speed | awk '{print $2}' | awk -FM '{print $1}'"
    # echo ${cmd}
    netcardspeed=`ethtool ${netcard} | grep Speed | awk '{print $2}' | awk -FM '{print $1}'`
    
    if [[ ${netcardspeed} >  ${maxnetcardspeed}  ]]; then
      # echo "netcardspeed: "   ${netcardspeed} 
      maxnetcardspeed=${netcardspeed}
      maxnetcard=${netcard}
    fi
  done
  # echo "maxnetcard " ${maxnetcard} "maxnetcardspeed: " ${maxnetcardspeed} 
  if [[ -z ${maxnetcard} ]]; then
    # echo  "no available network card "
    exit 1
  fi
  MAX_SPEED_NETCARD=${maxnetcard}

  if [[ -z ${MAX_SPEED_NETCARD} ]]; then
  echo "no available network card "
  exit 1
fi
}

stop_pppd_monitor() {
  killall -9 pear_ppp_monitor.sh
  killall -9 pear_findppp
  sleep 10
}

stop_pppd() {
  check_ppp0_status
  # kill all virtual pppd 
  ps -aux | grep pppd | grep options |grep -v colr | grep -v moni| awk '{print $2}' | awk '{system("kill -9  " $1)}'

  pppdresult=`ps -aux | grep pppd | grep options |grep -v colr | grep -v moni| awk '{print $2}'`
  while [[ -n ${pppdresult} ]]; do
    sleep 2
    pppdresult=`ps -aux | grep pppd | grep options |grep -v colr | grep -v moni| awk '{print $2}'`
  done
}

pear_multiple_dial(){

  if [[ -z ${PEAR_MACHINE_NAME} ]]; then
    echo "please input PEAR_MACHINE_NAME, default is common:"
    read PEAR_MACHINE_NAME
    if [[ -z ${PEAR_MACHINE_NAME} ]]; then
      PEAR_MACHINE_NAME="common"
    fi
  fi

  cd /root/pear/multidial

  DIAL_ACCOUNT_NAME=${PEAR_MACHINE_NAME}"_account.txt"

  if [[ ! -f  ${DIAL_ACCOUNT_NAME}  ]]; then
    exit 1
  fi

  ./pear_multiple -b -g ${DIAL_ACCOUNT_NAME} -w aa:bb:cc:dd:ee:ff
}

ppp0_dial() {
  ppp0_inet_status=`ifconfig ppp0 | grep inet`
  if [[ -z ${ppp0_inet_status} ]]; then
    cd  /etc/ppp/peers/ 
    pon dsl-provider
    main_dial_ts=`date +%s`
    touch ${LOGDIR}/ppp0_${main_dial_ts}_result
    plog >> ${LOGDIR}/ppp0_${main_dial_ts}_result
    sleep 2
    plog >> ${LOGDIR}/ppp0_${main_dial_ts}_result
    sleep 2
    plog >> ${LOGDIR}/ppp0_${main_dial_ts}_result
  fi

  ppp0_inet_status=`ifconfig ppp0 | grep inet`
  if [[ -n ${ppp0_inet_status} ]]; then
    echo "ppp0 normla exit  "   >> ${LOGDIR}/ppp0_${main_dial_ts}_result 
  else
    echo "ppp0 fail"   >> ${LOGDIR}/ppp0_${main_dial_ts}_result 
  fi

}

down_virtural_card() {

  check_ppp0_status
  virtual_net_cars=`ifconfig | grep veth | awk '{print $1}' | sed -e 's/://g' `


  if [[ -n ${virtual_net_cars} ]]; then
    for virtual_net_car in ${virtual_net_cars[@]}
    do
      ifconfig  ${virtual_net_car}  down 
      cmd="ip link delete ${virtual_net_car}"
      echo ${cmd}
      ${cmd}

      ifconfig ${virtual_net_car} 2> ${LOGDIR}/${virtual_net_car}.status 
      temp=`cat ${LOGDIR}/${virtual_net_car}.status `
      echo ${temp}

      while [[ -z ${temp} ]]; do
        sleep 2
        ifconfig ${virtual_net_car} 2> ${LOGDIR}/${virtual_net_car}.status 
        temp=`cat ${LOGDIR}/${virtual_net_car}.status `
        echo ${temp}
      done
    done
  else
    virtual_net_cars=`ip link | grep veth |  awk '{print $2}' | sed -e 's/://g'  | awk -F@ '{print $1}'`
    if [[ -n ${virtual_net_cars} ]]; then
      for virtual_net_car in ${virtual_net_cars[@]}
      do
        cmd="ip link delete ${virtual_net_car}"
        echo ${cmd}
        ${cmd}        
      done
    fi
  fi
}

add_virtural_link() {

  check_ppp0_status

  WORKING_NETCARD=${MAX_SPEED_NETCARD}
  VLANCARD=`cat /proc/net/vlan/config | grep ${MAX_SPEED_NETCARD} | awk -F\| '{print $1}' | sed 's/ //g' `
  # vlan=`cat /proc/net/vlan/config | grep ${MAX_SPEED_NETCARD} | awk '{print $1}' | awk -F . '{print $2}'`
  
  if [[ -n ${VLANCARD} ]]; then
    result=`ifconfig  ${VLANCARD}  | grep RUNNING`
    echo "result: " ${result}

    if [[ -n ${result} ]]; then
      WORKING_NETCARD=${VLANCARD}
    else
      echo "vlan card not running, please check it "
      exit 1
    fi
  fi
  
  echo "WORKING_NETCARD: " ${WORKING_NETCARD}

  for i in `seq 0 $((DIAL_ACCOUNT_NUMBER-1)) `
  do 
    cmd="sudo ip link add link ${WORKING_NETCARD} name veth${i} type macvlan "
    echo ${cmd}
    ${cmd}
  done

}

check_ppp0_status() {

  ifconfig  ppp0  2> /tmp/ppp0_abnormal  1>> /tmp/ppp0_status
  ppp0_status=$(cat /tmp/ppp0_abnormal)
  if [[ -n ${ppp0_status} ]]; then
    echo "ppp0 status abnormal : " ${ppp0_status}
    exit 1
  fi

  ppp0_running=`ifconfig ppp0 | grep RUNNING  | awk '{print $1}' | sed -e 's/://g' `
  if [[ ${ppp0_running} != "ppp0" ]]; then
    echo "ppp0 not running, exit"
    exit 1
  fi

}

start_ppp_monitor() {
    check_ppp0_status
    /root/pear/multidial/pear_ppp_monitor.sh &   
}

create_multiple_dial_route() {
  check_ppp0_status
  /root/pear/multidial/pear_findppp -b -m aa:bb:cc:dd:ee:ff 
}


testallppp() {
  ppptimestamp=`date +%s`
  touch ${LOGDIR}/ppp_${ppptimestamp}.result 

  if [[  ${REGION} == "jiangxi" ]]; then
    PPP_NUMBER=20
  else
    PPP_NUMBER=${DIAL_ACCOUNT_NUMBER}
  fi

  for i in `seq 0 $((PPP_NUMBER-1)) `  
  do 
    cmd="ping -c 2 -I ppp${i} qq.com "
    echo ${cmd}
    pingresult=$(${cmd}  2>&1)
    echo ${pingresult}
    echo ppp${i} " : " ${pingresult}  >>  ${LOGDIR}/ppp_${ppptimestamp}.result 
  done

  cmd="cat ${LOGDIR}/ppp_${ppptimestamp}.result | grep -v ' 2 received' | awk '{print \$1}'"
  echo ${cmd}
  failresult=`cat ${LOGDIR}/ppp_${ppptimestamp}.result | grep -v ' 2 received' | awk '{print $1}'   2>&1 `


  sed -i '/ppptest/d'  /root/pear/${PEAR_MACHINE_NAME}_parm.conf
  for fail_ppp_netcard in ${failresult[@]}
  do
    fail_id=${fail_ppp_netcard:3}
    if [[ ${fail_id} == 0 ]]; then
      echo "ppp0 error, stop test, please handle ppp0 firstly"
      exit 1
    fi

    unit=`cat /etc/ppp/options.prfile$((fail_id-1)) | grep unit | awk '{print $2}'`
    if [[ ${unit} != ${fail_id} ]]; then
      exit  0
    fi
    fail_user=`cat /etc/ppp/options.prfile$((fail_id-1)) | grep user  | awk '{print $2}' | awk -F\' '{print $2}'`
    fail_vethnetcard=`cat /etc/ppp/options.prfile$((fail_id-1))  | grep veth | awk '{print $3}'`

    cmd="ps -aux | grep pppd | grep 'prfile$((fail_id-1)) ' |  awk '{print $2}'"
    fail_ps_id=`ps -aux | grep pppd | grep prfile$((fail_id-1))$ |  awk '{print $2}'` 
    echo "ppptest: " ${ppptimestamp} "_" ${fail_ppp_netcard} "_" ${fail_user}  "_"   ${fail_vethnetcard}  "_"  ${fail_ps_id} >> /root/pear/${PEAR_MACHINE_NAME}_parm.conf
  done 
}

multidial() {

  cd /root/pear/multidial

  stop_pppd_monitor

  stop_pppd 

  down_virtural_card

  add_virtural_link

  pear_multiple_dial

  create_multiple_dial_route
    
  start_ppp_monitor

  testallppp
}

case "$1" in
  multidial)
    find_max_speed_netcard
    multidial
    ;;
  testallppp)
    testallppp
    ;;
  ppp0_dial)
    ppp0_dial
    ;;
  *)
    exit 1
esac

exit 0
